using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace SampleGame
{
    /// <summary>
    /// `SNX
    /// </summary>
    public static class DrawManager
    {
        // [hs
        static public Matrix m_world = Matrix.Identity;
        // r[s
        static public Matrix m_camera = Matrix.Identity;
        // es
        static public Matrix m_projection = Matrix.Identity;

        /// <summary>s܂</summary>
        public static void Initialize()
        {
        }

        /// <summary>Wݒ肵܂</summary>
        /// <param name="clientBounds">`̈</param>
        public static void SetCoodinate(Rectangle clientBounds)
        {
            // _s
            //m_camera = Matrix.CreateLookAt(new Vector3(1000, 1000, 500), Vector3.Zero, Vector3.Up);
            m_camera = Matrix.CreateLookAt(
                // J̈ʒu
                new Vector3(0, 1000, -1000),
                // J̐
                new Vector3(0, 0, 1000),
                Vector3.Up);

            // ˉes
            m_projection = Matrix.CreatePerspectiveFieldOfView(
                // p(Ƃ肠 45 x)
                (float)Math.PI / 4,
                // AXyNg
                (float)clientBounds.Width / (float)clientBounds.Height,
                // jANbvʂ̋
                1f,
                // t@[Nbvʂ̋
                10000.0f);
        }

        /// <summary>C`s܂</summary>
        /// <param name="graphics">OtBbN</param>
        public static void Draw(GraphicsDevice graphics)
        {
            // f`悵܂
            DrawModel();

            // XvCg`悵܂
            DrawSprite();
        }

        /// <summary>f`悵܂</summary>
        static void DrawModel()
        {
            // o^ĂIuWFNg̕`s܂
            int count = Global.m_taskManager.Count;
            for (int i = 0; i < count; i++)
            {
                CharacterTask baseTask = Global.m_taskManager.m_drawManager[i];

                // \̏ꍇ͕`s܂
                if (baseTask.m_show == false)
                {
                    continue;
                }

                // fLN^[łȂꍇ̓XLbv܂
                if ((baseTask.m_taskAttribute & Task.ATTRIBUTE_CHARACTER_MODEL) == 0)
                {
                    continue;
                }

                // f`悵܂
                baseTask.Draw();
            }
        }

        /// <summary>f`悵܂</summary>
        /// <param name="model">f</param>
        /// <param name="position">fSW</param>
        /// <param name="rotate">]</param>
        /// <param name="scaleOn">XP[̉(true:s, false:sȂ)</param>
        /// <param name="scale">XP[</param>
        /// <param name="alphaOn">߂̉(true:s, false:sȂ)</param>
        /// <param name="alpha">ߏ</param>
        /// <remarks>
        /// ߏꍇ Z obt@񂪂Ȃ̂
        /// `sIuWFNg̔zɔCӂŃL[COs悤ɂĂ
        /// </remarks>
        public static void DrawModel(
            Model model, Vector3 position, Vector3 rotate,
            bool scaleOn, Vector3 scale,
            bool alphaOn, float alpha)
        {
            // {[̌ϊs擾܂
            Matrix[] transforms = new Matrix[model.Bones.Count];
            model.CopyAbsoluteBoneTransformsTo(transforms);

            // f`悷
            foreach (ModelMesh mesh in model.Meshes)
            {
                //bV̊eGtFNgݒ
                foreach (BasicEffect effect in mesh.Effects)
                {
                    // Ƃ肠݂̓ftHg̃Cg
                    effect.EnableDefaultLighting();

                    // r[
                    effect.View = m_camera;
                    // ˉe
                    effect.Projection = m_projection;
                    // Lkꍇ
                    // (}gNX|I[o[wbhǂꂭ炢Ȃ̂łƂ肠𕪂܂)
                    if (scaleOn == false)
                    {
                        // [h
                        effect.World = transforms[mesh.ParentBone.Index] *
                            Matrix.CreateRotationZ(rotate.Z) *
                            Matrix.CreateRotationX(rotate.X) *
                            Matrix.CreateRotationY(rotate.Y) *
                            Matrix.CreateTranslation(position);
                    }
                    // Lkꍇ
                    else
                    {
                        // [h
                        effect.World = transforms[mesh.ParentBone.Index] *
                            Matrix.CreateScale(scale) *
                            Matrix.CreateRotationZ(rotate.Z) *
                            Matrix.CreateRotationX(rotate.X) *
                            Matrix.CreateRotationY(rotate.Y) *
                            Matrix.CreateTranslation(position);
                    }
                    // 
                    if (alphaOn == true)
                    {
                        effect.Alpha = alpha;
                    }
                    else
                    {
                        effect.Alpha = 1;
                    }
                }
                mesh.Draw();
            }
        }

        /// <summary>XvCg`悵܂</summary>
        static void DrawSprite()
        {
            SpriteTool.m_sprite.Begin();

            // o^ĂIuWFNg̕`s܂
            int count = Global.m_taskManager.Count;
            for (int i = 0; i < count; i++)
            {
                CharacterTask baseTask = Global.m_taskManager.m_drawManager[i];

                // \̏ꍇ͕`s܂
                if (baseTask.m_show == false)
                {
                    continue;
                }

                // XvCgLN^[łȂꍇ̓XLbv܂
                if ((baseTask.m_taskAttribute & Task.ATTRIBUTE_CHARACTER_SPRITE) == 0)
                {
                    continue;
                }

                // XvCg`悵܂
                baseTask.Draw();
            }

            SpriteTool.m_sprite.End();
        }

        /// <summary>XvCg̕`s܂</summary>
        /// <param name="texture">eNX`</param>
        /// <param name="drawRect">`ʒuƃTCY</param>
        /// <param name="color">F</param>
        public static void DrawSprite(Texture2D texture, Rectangle drawRect, Color color)
        {
            // XP[O܂({͂͂肽Ȃ...)
            drawRect = SpriteCharacterTask.WindowNormalize(drawRect);

            // XvCg`悵܂
            SpriteTool.m_sprite.Draw(
                texture,
                drawRect,
                new Rectangle(0, 0, texture.Width, texture.Height),
                color);
        }
    }
}
