using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;

namespace SampleGame
{
    /// <summary>Ǘ</summary>
    public class SoundManager : SortedDictionary<SoundID, SoundItem>
    {
        // I[fBIGW
        public AudioEngine m_audioEngine;
        // EF[uoN
        public WaveBank m_waveBank;
        // TEhoN
        public SoundBank m_soundBank;

        /// <summary>s</summary>
        /// <returns>
        /// ʃR[h
        /// 1		I
        /// 1ȊO	G[
        /// </returns>
        public int Initialize()
        {
            // I[fBIGW
            m_audioEngine = new AudioEngine(SoundName.AudioEngine);
            if (m_audioEngine == null)
            {
                return -1;
            }
            // EF[uoN
            m_waveBank = new WaveBank(m_audioEngine, SoundName.WaveBank);
            if (m_waveBank == null)
            {
                return -2;
            }
            // TEhoN
            m_soundBank = new SoundBank(m_audioEngine, SoundName.SoundBank);
            if (m_soundBank == null)
            {
                return -3;
            }

            // Ƃ肠ŉo^܂
            Add(SoundID.BGM1, SoundType.BGM, SoundName.BGM1, 0);
            Add(SoundID.ShipMissile, SoundType.SE, SoundName.ShipMissile);

            return 1;
        }

        /// <summary>o^܂</summary>
        /// <param name="id"> ID</param>
        /// <param name="type"></param>
        /// <param name="name">̖O</param>
        public void Add(SoundID id, SoundType type, string name)
        {
            Add(id, type, SoundDataFormatType.WAV, name, 1);
        }

        /// <summary>o^܂</summary>
        /// <param name="id"> ID</param>
        /// <param name="type"></param>
        /// <param name="name">̖O</param>
        public void Add(SoundID id, SoundType type, string name, int loopCount)
        {
            Add(id, type, SoundDataFormatType.WAV, name, loopCount);
        }

        /// <summary>o^܂</summary>
        /// <param name="id"> ID</param>
        /// <param name="type"></param>
        /// <param name="format">f[^tH[}bg</param>
        /// <param name="name">̖O</param>
        /// <param name="loopCount">[v</param>
        public void Add(
            SoundID id,
            SoundType type, SoundDataFormatType format, string name, int loopCount)
        {
            // do^͋֎~܂
            if (ContainsKey(id) == true)
            {
                return;
            }

            // ڂo^܂
            SoundItem item = new SoundItem();
            item.m_id = id;
            item.m_fileName = name;
            item.m_loopCount = loopCount;

            base.Add(id, item);
        }

        /// <summary>s܂</summary>
        /// <remarks>ۂɂ͍XV܂</remarks>
        public void Execute()
        {
            // XVsȂƂȂȂ(ƃhLgɏĂ)
            m_audioEngine.Update();

            // [v
            foreach (KeyValuePair<SoundID, SoundItem> data in this)
            {
                SoundItem item = data.Value;

                // IĂ鉹[vݒ̏ꍇ̓[v܂
                if(
                    ((item.m_loopCount == 0) ||
                    (item.m_playCount < item.m_loopCount)) &&
                    (item.m_cue != null)
                )
                {
                    if (item.m_cue.IsStopped == true)
                    {
                        item.m_playCount++;
                        item.m_cue = m_soundBank.GetCue(item.m_fileName);
                        item.m_cue.Play();
                    }
                }
            }
        }

        /// <summary>Đ܂</summary>
        /// <param name="id"> ID</param>
        public void Play(SoundID id)
        {
            // L[܂܂Ă邩mF܂
            if (ContainsKey(id) == false)
            {
                return;
            }

            // Đ܂
            SoundItem item = this[id];
            item.m_playCount = 1;
            item.m_cue = m_soundBank.GetCue(item.m_fileName);
            item.m_cue.Play();
        }

        /// <summary>~܂</summary>
        /// <param name="id"> ID</param>
        public void Stop(SoundID id)
        {
            // L[܂܂Ă邩mF܂
            if (ContainsKey(id) == false)
            {
                return;
            }

            // ~܂
            SoundItem item = this[id];
            // Đ񐔈ȏ̐lݒ肵܂(Ƃ肠9999őƂĂ܂)
            item.m_playCount = 9999;
            item.m_cue = m_soundBank.GetCue(item.m_fileName);
            item.m_cue.Stop(AudioStopOptions.AsAuthored);
        }
    }
}
