using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace SampleGame
{
    /// <summary>XvCgLN^[</summary>
    public class SpriteCharacterTask : CharacterTask
    {
        // ݂̃XvCg
        public Texture2D m_texture = null;
        // XvCg̕\ʒu
        public Rectangle m_drawRect = new Rectangle();
        // XvCĝ킹F
        public Color m_channelColor = Color.White;

        /// <summary>RXgN^</summary>
        public SpriteCharacterTask()
            : base(ID.DEFAULT, ATTRIBUTE_CHARACTER_SPRITE, 0)
        {
        }

        /// <summary>RXgN^</summary>
        /// <param name="taskID">^XN IDiTask.ID ܂͔CӁj</param>
        public SpriteCharacterTask(ID taskID)
            : base(taskID, ATTRIBUTE_CHARACTER_SPRITE, 0)
        {
        }

        /// <summary>RXgN^</summary>
        /// <param name="taskID">^XN IDiTask.ID ܂͔CӁj</param>
        /// <param name="taskAttribute">^XNiTask.ATTRIBUTE_* ܂͔CӁj</param>
        public SpriteCharacterTask(ID taskID, uint taskAttribute)
            : base(taskID, taskAttribute | ATTRIBUTE_CHARACTER_SPRITE, 0)
        {
        }

        /// <summary>RXgN^</summary>
        /// <param name="taskID">^XN ID (Task.ID.*)</param>
        /// <param name="taskNo">^XNԍ(Cӂ̔ԍ)</param>
        public SpriteCharacterTask(ID taskID, int taskNo)
            : base(taskID, taskNo)
        {
        }

        /// <summary>RXgN^</summary>
        /// <param name="taskID">^XN IDiTask.ID ܂͔CӁj</param>
        /// <param name="taskAttribute">^XNiTask.ATTRIBUTE_* ܂͔CӁj</param>
        /// <param name="taskNo">^XNԍ(Cӂ̔ԍ)</param>
        public SpriteCharacterTask(ID taskID, uint taskAttribute, int taskNo)
            : base(taskID, taskAttribute | ATTRIBUTE_CHARACTER_SPRITE, taskNo)
        {
        }

        /// <summary>eNX`ݒ肵܂</summary>
        /// <param name="assetName">eNX`AZbg</param>
        public void SetTexture(string assetName)
        {
            m_texture = SpriteTool.LoadSprite(assetName);
        }

        /// <summary>Wݒ肵܂</summary>
        /// <param name="xy">W</param>
        public virtual void SetCoordinate(Point xy)
        {
            m_drawRect.X = xy.X;
            m_drawRect.Y = xy.Y;

            // TCYݒ肳ĂȂ΃eNX`̃TCYݒ肵܂
            if ((m_drawRect.Width == 0) && (m_drawRect.Height == 0))
            {
                if (m_texture == null)
                {
                    return;
                }
                m_drawRect.Width = m_texture.Width;
                m_drawRect.Height = m_texture.Height;
            }
        }

        /// <summary>Wݒ肵܂</summary>
        /// <param name="rect">W</param>
        public virtual void SetCoordinate(Rectangle rect)
        {
            m_drawRect = rect;
        }

        /// <summary>`Cxg</summary>
        public override void Draw()
        {
            // XvCgꍇ͕`ł܂
            if (m_texture == null)
            {
                return;
            }

            // XvCg`悵܂
            DrawManager.DrawSprite(m_texture, m_drawRect, m_channelColor);
        }

        /// <summary>XN[ʍWʕ\WɃm[}CY܂</summary>
        /// <param name="rect">XN[ʍW</param>
        /// <returns>ʕ\W</returns>
        public static Rectangle WindowNormalize(Rectangle rect)
        {
            // XP[O܂({͂͂肽Ȃ...)
            Rectangle result = new Rectangle();
            result.X = (int)MathTool.TranslatePoint(0, Global.m_screenSize.X, 0, Global.m_screenNormalSize.X, rect.X);
            result.Y = (int)MathTool.TranslatePoint(0, Global.m_screenSize.Y, 0, Global.m_screenNormalSize.Y, rect.Y);
            result.Width = (int)MathTool.TranslatePoint(0, Global.m_screenSize.X, 0, Global.m_screenNormalSize.X, rect.Width);
            result.Height = (int)MathTool.TranslatePoint(0, Global.m_screenSize.Y, 0, Global.m_screenNormalSize.Y, rect.Height);
            return result;
        }
    }
}
